unit pref_form;

interface

uses
{$IFDEF FPC}LResources,{$ENDIF}
  {$IFNDEF UNIX}Windows,{$ENDIF} Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,filename,define_types,dicomtypes,prefs, Spin, Buttons;

type
{$H+}

  { TPrefsForm }

  TPrefsForm = class(TForm)
    FilenameBox: TGroupBox;
    DateCheck: TCheckBox;
    SeriesCheck: TCheckBox;
    ProtocolCheck: TCheckBox;
    PatientNameCheck: TCheckBox;
    InputNameCheck: TCheckBox;
    NotAnonymizeCheck: TCheckBox;
    ReorientCheck: TCheckBox;
    OKBtn: TButton;
    CancelBtn: TButton;
    RecursiveSpin: TSpinEdit;
    Label1: TLabel;
    procedure FilenameChecks(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
    procedure ReadPrefs(var lPrefs: TPrefs);
    procedure WritePrefs(var lPrefs: TPrefs);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PrefsForm: TPrefsForm;

implementation
{$IFNDEF FPC}
{$R *.DFM}
{$ENDIF}
var
   gPrefs: TPrefs;

procedure TPrefsForm.WritePrefs(var lPrefs: TPrefs);
begin
     gPrefs := lPrefs;
     DateCheck.Checked := lPrefs.AppendDate;
     SeriesCheck.Checked := lPrefs.AppendAcqSeries;
     ProtocolCheck.Checked := lPrefs.AppendProtocolName;
     PatientNameCheck.Checked := lPrefs.AppendPatientName;
     InputNameCheck.checked := lPrefs.AppendFilename;
     ReorientCheck.Checked := (lPrefs.MinReorientMatrix < 32000);
     NotAnonymizeCheck.Checked := not lPrefs.Anonymize;
     //SaveToBaseFolderCheck.Checked := lPrefs.SaveToBaseFolder;
     RecursiveSpin.Value := lPrefs.RecursiveFolderDepth;

end;

procedure TPrefsForm.ReadPrefs(var lPrefs: TPrefs);
begin
    lPrefs := gPrefs;
    lPrefs.AppendDate := DateCheck.Checked;
    lPrefs.AppendAcqSeries := SeriesCheck.Checked;
    lPrefs.AppendProtocolName := ProtocolCheck.Checked;
    lPrefs.AppendPatientName := PatientNameCheck.Checked;
    lPrefs.AppendFilename := InputNameCheck.checked;
    //lPrefs.SaveToBaseFolder := SaveToBaseFolderCheck.Checked;
    if ReorientCheck.Checked then
       lPrefs.MinReorientMatrix := 255
    else
        lPrefs.MinReorientMatrix := MaxInt;
    lPrefs.Anonymize := not NotAnonymizeCheck.Checked;
    lPrefs.RecursiveFolderDepth := RecursiveSpin.Value;
end;

procedure TPrefsForm.FilenameChecks(Sender: TObject);
var
   lDICOMImgName: string;
   lDicomData: DICOMdata;
   lPrefs: TPrefs;

begin
   Clear_Dicom_Data(lDicomData);
   SetDefaultPrefs (lPrefs);
   ReadPrefs(lPrefs);
  clear_dicom_data(lDicomData);
   lDICOMImgName:= 'IM_0160';
   //lDicomData.StudyDate := '1/1/1970';
   lDicomData.PatientName := 'JOHNDOE';
   lDicomData.ProtocolName := 'AnatT1';
   //FilenameBox.Caption := 'Output Filename ('+  OutputFilename(lDicomImgName,lDicomData,lPrefs.AppendDate,lPrefs.AppendAcqSeries,lPrefs.AppendProtocolName,lPrefs.AppendPatientName,lPrefs.FourD,lPrefs.AppendFilename)+')';
   FilenameBox.Caption := 'Output Filename ('+  OutputFilename(lDicomImgName,lDicomData,lPrefs)+')';
   
end;

procedure TPrefsForm.OKbtnClick(Sender: TObject);
begin

end;

{$IFDEF FPC}
initialization
  {$I pref_form.lrs}
 {$ENDIF}

end.
